#define GAME_DLL
#include <interface.h>
#include <cbase.h>
#include <eiface.h>
#include <gmodinterface/gmluamodule.h>

IVEngineServer* engine = NULL;
GMOD_MODULE(Init, Shutdown);

edict_t* GetEdict(ILuaInterface* ILua, int arg) {
	ILuaObject* EntityObj = ILua->GetObject(arg);
	ILuaObject* Entity = ILua->GetMetaTable("Entity", GLua::TYPE_ENTITY);
	ILuaObject* EntIndex = Entity->GetMember("EntIndex");
	EntIndex->Push();
	EntityObj->Push();
	ILua->Call(1, 1);
	ILuaObject* ret = ILua->GetReturn(0);
	edict_t* ed = engine->PEntityOfEntIndex( ret->GetInt() );
	return ed;
}

LUA_FUNCTION(ServerCommand) {
	Lua()->CheckType(1, GLua::TYPE_STRING);
	engine->ServerCommand(Lua()->GetString(1));
	return 0;
}
int Init(lua_State* L) {
	CreateInterfaceFn interfaceFactory = Sys_GetFactory("engine.dll");
	engine = (IVEngineServer*)interfaceFactory(INTERFACEVERSION_VENGINESERVER, NULL);
	if(!engine) return 0;
	ILuaInterface* gLua = Lua();
	Lua()->NewGlobalTable("command");
	ILuaObject* database = Lua()->GetGlobal("command");
		database->SetMember("ServerCommand", ServerCommand);
	return 0;
}
int Shutdown(lua_State* L)
{
	return 0;
}


